#ifndef _URLLockNative_H_
#define _URLLockNative_H_

#define MOZILLA_STRICT_API
#define _WIN32_WINNT 0x0400
#include "URLLockLibrary.h"
#include <windows.h>
#include <lm.h>

/* Undefine Windows's definition of GetUserName as it conflicts with our class function
   declaration */
#undef GetUserName

#define URLLOCKNATIVE_CONTRACTID "@ieurllock.sourceforge.net/native;1"
#define URLLOCKNATIVE_CLASSNAME "URL Lock Native"
#define URLLOCKNATIVE_CID {0xab432666, 0x2f11, 0x4db5, { 0x89, 0xb9, 0x16, 0xcb, 0xad, 0xb3, 0xe5, 0xf1 }}

/* USER_INFO_2 array wrapper for nsISupportsVoid */
class UserInfoSupportsVoid : public nsISupportsVoid
{
public:
    NS_DECL_ISUPPORTS
	NS_DECL_NSISUPPORTSPRIMITIVE
	NS_DECL_NSISUPPORTSVOID

	UserInfoSupportsVoid(PUSER_INFO_2 userInfo);
	UserInfoSupportsVoid(nsISupports *parent, PUSER_INFO_2 userInfo);

private:
	~UserInfoSupportsVoid();
	
protected:
	PUSER_INFO_2 userInfo;
	nsISupports *parent;
};

/* Header file */
class URLLockNative : public IURLLockNative
{
public:
    NS_DECL_ISUPPORTS
    NS_DECL_IURLLOCKNATIVE

    URLLockNative();
	static char* convertUnicodeToMozillaASCII(LPCWSTR unicodeString);

private:
    ~URLLockNative();

protected:
};

#endif //_URLLockNative_H_
